## mimic 0.6.3+ds

=== Makefile ===
mimic_common_headers := $(wildcard common/*.h)

mimic_bpf_src := $(wildcard bpf/*.c)
mimic_bpf_obj := $(mimic_bpf_src:.c=.o)
mimic_bpf_headers := bpf/vmlinux.h $(wildcard bpf/*.h) $(mimic_common_headers)

mimic_src := $(wildcard src/*.c)
mimic_obj := $(mimic_src:.c=.o)
mimic_headers := src/bpf_skel.h $(wildcard src/*.h) $(mimic_common_headers)
mimic_link_libs := -lbpf -lffi

mimic_tools := $(patsubst tools/%.c,%,$(wildcard tools/*.c))

# Compile options

BPF_CC ?= clang
BPFTOOL ?= /usr/sbin/bpftool
LLVM_STRIP ?= llvm-strip

# -g is required (by Clang) to generate BTF
# for bpf-gcc, use -mcpu=v3 -gbtf -mco-re -O2
BPF_TARGET ?= bpf
BPF_CFLAGS += --target=$(BPF_TARGET) -mcpu=v3 -g -O2

BPF_CFLAGS += -iquote. -Wall -std=gnu99
CFLAGS += -iquote. -Wall -std=gnu99

# Specify compiler option presets
MODE ?=
ifeq ($(MODE), debug)
CFLAGS += -O0 -g
else ifeq ($(MODE), release)
CFLAGS += -O2
endif

ifeq ($(USE_LIBXDP),)
ifeq ($(shell pkg-config --exists 'libxdp >= 1' 'libxdp < 2' >/dev/null 2>&1; echo $$?),0)
USE_LIBXDP := 1
endif
endif
ifeq ($(USE_LIBXDP),1)
BPF_CFLAGS += -DMIMIC_USE_LIBXDP
CFLAGS += -DMIMIC_USE_LIBXDP
# mimic_link_libs += -lxdp
endif

# Whether to use argp-standalone
#
# If host glibc is detected, the option is automatically enabled. This
# behaviour can be overriden.
ifeq ($(ARGP_STANDALONE),)
ifeq ($(filter "gnu libc" "glibc" "free software foundation",$(shell ldd --version 2>&1 | tr '[A-Z]' '[a-z]')),)
ARGP_STANDALONE := 1
endif
endif
ifeq ($(ARGP_STANDALONE),1)
mimic_link_libs += -largp
endif

# Whether to link CLI statically
ifneq ($(STATIC)$(STATIC_EXCEPT_LIBC),)
mimic_link_libs += -lelf -lzstd -lz
endif

ifneq ($(STATIC_EXCEPT_LIBC),)
LDFLAGS += -Wl,-Bstatic
endif

LDFLAGS += $(mimic_link_libs)

ifneq ($(STATIC_EXCEPT_LIBC),)
LDFLAGS += -Wl,-Bdynamic
endif
ifneq ($(STATIC),)
LDFLAGS += -static
endif

# Specify path of vmlinux for generating bpf/vmlinux/system.h
ifeq ($(KERNEL_VMLINUX),)
ifeq ($(KERNEL_UNAME),)
KERNEL_VMLINUX := /sys/kernel/btf/vmlinux
else ifeq ($(KERNEL_UNAME),$(shell uname -r))
KERNEL_VMLINUX := /sys/kernel/btf/vmlinux
else ifneq ($(wildcard /usr/lib/debug/lib/modules/$(KERNEL_UNAME)/vmlinux),)
KERNEL_VMLINUX := /usr/lib/debug/lib/modules/$(KERNEL_UNAME)/vmlinux
else ifneq ($(wildcard /lib/modules/$(KERNEL_UNAME)/build/vmlinux),)
KERNEL_VMLINUX := /lib/modules/$(KERNEL_UNAME)/build/vmlinux
endif  # KERNEL_UNAME
endif  # KERNEL_VMLINUX

# Specify whether to use system vmlinux
ifneq ($(BPF_USE_SYSTEM_VMLINUX),)
BPF_CFLAGS += -DMIMIC_BPF_USE_SYSTEM_VMLINUX
use_system_vmlinux_req := bpf/vmlinux/system.h
else
BPF_CFLAGS += -DMIMIC_BPF_TARGET_ARCH_$(shell $(CC) -dumpmachine | sed 's/-.*//')
endif  # BPF_USE_SYSTEM_VMLINUX

# Mimic runtime directory, where the lock files are stored
RUNTIME_DIR ?= /run/mimic
CFLAGS += -DMIMIC_RUNTIME_DIR="\"$(RUNTIME_DIR)\""

# Select packet checksum hack method
#
# When transport header changes from UDP to TCP in TC, skb->csum_offset still
# points to UDP's checksum position. Some network drivers may use the value to
# do checksum offload, causing packet corruption. This field is not accesible
# through BPF's `struct __sk_buff`, so we have to use kernel module to hack
# into `struct sk_buff`.
#
# Selecting kfunc requires CONFIG_DEBUG_INFO_BTF=y, and running the compiled
# Mimic requires loading the corresponding kernel module.
#
# Using kprobe requires CONFIG_KRETPROBES=y and CONFIG_KALLSYMS=y, and making
# the kernel module optional. The hack simply goes out of effect if the module
# is not loaded.
CHECKSUM_HACK ?= kfunc
ifeq ($(filter kfunc kprobe,$(CHECKSUM_HACK)),)
$(error unknown checksum hack '$(CHECKSUM_HACK)')
endif
BPF_CFLAGS += -DMIMIC_CHECKSUM_HACK_$(CHECKSUM_HACK)
CFLAGS += -DMIMIC_CHECKSUM_HACK_$(CHECKSUM_HACK)

# Whether to strip .BTF.ext section from BPF object
#
# Removing the section removes dependency on kernel BTF and improves
# compatibility, but also makes the program lose CO-RE functionality.
STRIP_BTF_EXT ?=

# Rules

mkdir_p = mkdir -p $(@D)
check_options := out/.options.$(shell echo $(BPF_CC) $(CC) $(BPFTOOL) $(BPF_CFLAGS) $(CFLAGS) | sha256sum | awk '{ print $$1 }')

.PHONY: .FORCE
.FORCE:

all: build

.PHONY: build build-cli build-kmod build-tools
build: build-cli build-kmod build-tools
build-cli: out/mimic
build-kmod: out/mimic.ko
build-tools: $(patsubst %,out/%,$(mimic_tools))

.PHONY: generate-skel generate-manpage generate-pot generate-compile-commands
generate-skel: src/bpf_skel.h
generate-manpage: out/mimic.1.gz
generate-pot: out/mimic.pot
generate-compile-commands: compile_commands.json

.PHONY: generate-dkms generate-akms
generate-dkms:
	$(MAKE) -C kmod dkms.conf
generate-akms:
	$(MAKE) -C kmod AKMBUILD

.PHONY: test
test: build-cli
	bats tests

.PHONY: bench
bench: build-cli
	tests/bench.bash

.PHONY: clean
clean:
	$(MAKE) -C kmod $@
	rm -rf out/
	find . -type f -name *.o -delete
	rm -f src/bpf_skel.h
	rm -f bpf/vmlinux/system.h

out/.options.%:
	$(mkdir_p)
	rm -f out/.options.*
	touch $@

bpf/vmlinux/system.h:
ifneq ($(KERNEL_VMLINUX),)
	$(BPFTOOL) btf dump file $(KERNEL_VMLINUX) format c >$@
else
	@echo vmlinux file not found and KERNEL_VMLINUX not specified >&2
	@exit 1
endif

$(mimic_bpf_obj): bpf/%.o: bpf/%.c $(mimic_bpf_headers) $(use_system_vmlinux_req) $(check_options)
	$(BPF_CC) $(BPF_CFLAGS) -DMIMIC_BPF -c -o $@ $<

out/mimic.bpf.o: $(mimic_bpf_obj)
	$(mkdir_p)
	$(BPFTOOL) gen object $@ $(mimic_bpf_obj)
ifneq ($(STRIP_BTF_EXT),)
	$(LLVM_STRIP) --remove-section=.BTF.ext --no-strip-all $@
endif

src/bpf_skel.h: out/mimic.bpf.o
	$(BPFTOOL) gen skeleton out/mimic.bpf.o >$@

$(filter src/%.o, $(mimic_obj)): src/%.o: $(mimic_headers) $(check_options)

out/mimic: $(mimic_obj)
	$(mkdir_p)
	$(CC) $(CFLAGS) $(mimic_obj) -o $@ $(LDFLAGS)

out/mimic.ko: .FORCE build-tools
	$(mkdir_p)
	$(MAKE) -C kmod
	cp kmod/mimic.ko $@

define generate_tool_rule
out/$(1): tools/$(1).c $(mimic_common_headers) $(check_options)
	$$(mkdir_p)
	$(CC) $(CFLAGS) $$< -o $$@ $(LDFLAGS)
endef
$(foreach _tool,$(mimic_tools),$(eval $(call generate_tool_rule,$(_tool))))

out/mimic.1.gz: docs/mimic.1.md
	$(mkdir_p)
	ronn -r --pipe $< | gzip -c >$@

out/mimic.pot:
	$(mkdir_p)
	find src -type f -regex '.*\.[ch]' | xargs xgettext -k_ -kN_ -o $@ --

compile_commands.json: clean
	bear -- $(MAKE)

=== kmod/Makefile ===
obj-m += mimic.o
mimic-objs := main.o
ccflags-y := -DMIMIC_KMOD -std=gnu99 -Wno-error=declaration-after-statement

KERNEL_UNAME ?= $(shell uname -r)
SYSTEM_BUILD_DIR := /lib/modules/$(KERNEL_UNAME)/build

CHECKSUM_HACK ?= kfunc
ifeq ($(filter kfunc kprobe,$(CHECKSUM_HACK)),)
$(error unknown checksum hack '$(CHECKSUM_HACK)')
endif
mimic-objs += csum-hack-$(CHECKSUM_HACK).o
ccflags-y += -DMIMIC_CHECKSUM_HACK_$(CHECKSUM_HACK)

ifneq ($(CHECKSUM_HACK),kfunc)
build_dir := $(SYSTEM_BUILD_DIR)
else

# Notes on build hack:
#
# - Debian does not ship vmlinux nor resolve_btfids in
#   linux-headers like Arch Linux does, so we need to refer to externally
#   built one in order to build kernel module BTF successfully.
#
# - Ubuntu does not ship vmlinux, but provides resolve_btfids, and there
#   might be dead symlinks (e.g. rust/) inside. This needs to work around as
#   well.
#
# - Fedora does not provide resolve_btfids. However they ship the source code
#   of it inside /lib/modules/*.
#
# Other distributions lacking components necessary to build kernel module BTF
# can also use the hack in packaging.

ifneq ($(wildcard $(SYSTEM_BUILD_DIR)/vmlinux),)
vmlinux_exists := 1
else
vmlinux_exists := 0
endif  # vmlinux
ifneq ($(wildcard $(SYSTEM_BUILD_DIR)/tools/bpf/resolve_btfids/resolve_btfids),)
resolve_btfids_exists := 1
else
resolve_btfids_exists := 0
endif  # resolve_btfids

ifeq ($(vmlinux_exists)$(resolve_btfids_exists),11)
build_dir := $(SYSTEM_BUILD_DIR)
else
enable_build_hack := 1
build_dir := build

RESOLVE_BTFIDS ?= /usr/lib/mimic/resolve_btfids

path_extension := PATH="$$PATH:/usr/lib/mimic:$(CURDIR)/../out:$(CURDIR)/../tools"
VMLINUX_TO_BTF ?= $(path_extension) vmlinux-to-btf
export EXTRACT_VMLINUX ?= $(path_extension) extract-vmlinux
export EXTRACT_BTF ?= $(path_extension) extract-btf
export VMLINUX_SUFFIX ?= -$(KERNEL_UNAME)

endif  # vmlinux_exists, resolve_btfids_exists
endif  # CHECKSUM_HACK

all: build

.PHONY: build
build:
ifdef enable_build_hack
	-cp -rL $(SYSTEM_BUILD_DIR) $(build_dir)
ifeq ($(vmlinux_exists),0)
	$(VMLINUX_TO_BTF) >$(build_dir)/vmlinux
endif
ifeq ($(resolve_btfids_exists),0)
ifeq ($(wildcard $(RESOLVE_BTFIDS)),)
	@echo "ERROR: `resolve_btfids` not found; please compile it from Linux kernel source and re-run make with RESOLVE_BTFIDS=<path>"
	@exit 1
endif
	install -Dm755 $(RESOLVE_BTFIDS) $(build_dir)/tools/bpf/resolve_btfids/resolve_btfids
endif  # resolve_btfids_exists
endif  # enable_build_hack
	$(MAKE) -C $(build_dir) M=$(CURDIR) modules

.PHONY: clean
clean:
	rm -rf build dkms.conf AKMBUILD
	[ ! -d $(SYSTEM_BUILD_DIR) ] || $(MAKE) -C $(SYSTEM_BUILD_DIR) M=$(CURDIR) clean

dkms.conf: dkms.conf.in
	sed $^ \
		-e 's|@@EXTRA_OPTS@@|CHECKSUM_HACK=$(CHECKSUM_HACK)|' \
		-e 's|#MODULE_VERSION#|0.6.3|'> $@
AKMBUILD: AKMBUILD.in
	sed 's|@@EXTRA_OPTS@@|CHECKSUM_HACK=$(CHECKSUM_HACK)|' $^ > $@

=== debian/changelog ===
mimic (0.6.3+ds-1) unstable; urgency=medium

  * New upstream release
  * Add libxdp as suggested dependency through dlopen ELF metadata

 -- Eric Long <i@hack3r.moe>  Thu, 16 Jan 2025 13:50:08 +0800

mimic (0.6.2+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1087937)

 -- Eric Long <i@hack3r.moe>  Sun, 24 Nov 2024 00:02:42 +0800

=== debian/control ===
Source: mimic
Section: net
Priority: optional
Maintainer: Eric Long <i@hack3r.moe>
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-dkms,
 dh-sequence-dlopenlibdeps,
 dh-exec,
 clang,
 python3,
 bpftool,
 ronn,
 libbpf-dev,
 libffi-dev,
 libxdp-dev,
 linux-source,
 linux-headers-generic
Standards-Version: 4.7.0
Homepage: https://github.com/hack3ric/mimic
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/hacker/mimic
Vcs-Git: https://salsa.debian.org/hacker/mimic.git

Package: mimic
Architecture: amd64 arm64 powerpc ppc64 ppc64el riscv64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 mimic-modules (= ${binary:Version})
Recommends: ${dlopen:Recommends}
Suggests: ${dlopen:Suggests}
Description: eBPF UDP -> TCP obfuscator
 Mimic is an experimental UDP to TCP obfuscator designed to bypass UDP
 QoS and port blocking. Based on eBPF, it directly mangles data inside
 Traffic Control (TC) subsystem in the kernel space and restores data
 using XDP, achieving remarkably high performance compared to other
 projects, such as udp2raw or Phantun.
 .
 This package contains the Mimic CLI and eBPF packet handler.

Package: mimic-dkms
Section: kernel
Architecture: amd64 arm64 powerpc ppc64 ppc64el riscv64
Provides: mimic-modules (= ${binary:Version})
Conflicts: mimic-modules
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 binutils,
 pahole
Recommends:
 xz-utils,
 bzip2,
 lzma,
 lzop,
 lz4,
 zstd
Description: eBPF UDP -> TCP obfuscator (DKMS kernel module)
 Mimic is an experimental UDP to TCP obfuscator designed to bypass UDP
 QoS and port blocking. Based on eBPF, it directly mangles data inside
 Traffic Control (TC) subsystem in the kernel space and restores data
 using XDP, achieving remarkably high performance compared to other
 projects, such as udp2raw or Phantun.
 .
 This package uses DKMS to automatically build kernel module against
 current kernel.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_VERSION_UPSTREAM

IS_UBUNTU := $(shell dpkg-vendor --derives-from ubuntu > /dev/null 2>&1; echo $$?)

%:
	dh $@

override_dh_auto_configure:
	sed install/mimic@.service.in \
		-e 's|@@MIMIC_EXEC@@|/usr/bin/mimic|' \
		-e 's|@@MIMIC_CONFIG_PATH@@|/etc/mimic|' \
		-e 's|@@MIMIC_RUNTIME_DIR@@|mimic|' \
		> debian/mimic@.service
	sed kmod/dkms.conf.in \
		-e 's|@@EXTRA_OPTS@@|CHECKSUM_HACK=kfunc|' \
		> kmod/dkms.conf

override_dh_auto_build:
	tar xf `bash -c '_tarballs=(/usr/src/linux-source-*.tar.*); echo $${_tarballs[0]}'`
ifeq ($(IS_UBUNTU), 0)
	# Ubuntu's bpftool relies on current kernel, which is both inconsistent
	# with Debian and sbuild-unfriendly. Build from kernel source instead.
	make -C linux-source-*/tools/bpf/bpftool
	dh_auto_build -- build-cli build-tools generate-manpage \
		MODE= \
		USE_LIBXDP=1 \
		BPFTOOL=linux-source-*/tools/bpf/bpftool/bpftool
else
	dh_auto_build -- build-cli build-tools generate-manpage \
		MODE= \
		USE_LIBXDP=1
endif
	make -C linux-source-*/tools/bpf/resolve_btfids

override_dh_auto_test:

override_dh_dkms:
	dh_dkms -pmimic-dkms -V$(DEB_VERSION_UPSTREAM)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf linux-source-*
	rm -f debian/mimic@.service

## mimic 0.7.0+ds

=== Makefile ===
--- 
+++ 
@@ -127,6 +127,11 @@
 # compatibility, but also makes the program lose CO-RE functionality.
 STRIP_BTF_EXT ?=
 
+ifneq ($(COMPAT_LINUX_6_1),)
+CFLAGS += -DMIMIC_COMPAT_LINUX_6_1
+BPF_CFLAGS += -DMIMIC_COMPAT_LINUX_6_1
+endif
+
 # Rules
 
 mkdir_p = mkdir -p $(@D)
@@ -170,6 +175,7 @@
 	find . -type f -name *.o -delete
 	rm -f src/bpf_skel.h
 	rm -f bpf/vmlinux/system.h
+	rm -f kmod/dkms.conf kmod/AKMBUILD
 
 out/.options.%:
 	$(mkdir_p)

=== kmod/Makefile ===
--- 
+++ 
@@ -44,10 +44,12 @@
 endif  # resolve_btfids
 
 ifeq ($(vmlinux_exists)$(resolve_btfids_exists),11)
-build_dir := $(SYSTEM_BUILD_DIR)
 else
 enable_build_hack := 1
-build_dir := build
+
+BWRAP := bwrap \
+	--dev-bind / / \
+	--ro-bind overlay $(shell realpath $(SYSTEM_BUILD_DIR))
 
 RESOLVE_BTFIDS ?= /usr/lib/mimic/resolve_btfids
 
@@ -65,28 +67,28 @@
 .PHONY: build
 build:
 ifdef enable_build_hack
-	-cp -rL $(SYSTEM_BUILD_DIR) $(build_dir)
+	-cp -rL $(SYSTEM_BUILD_DIR) overlay
 ifeq ($(vmlinux_exists),0)
-	$(VMLINUX_TO_BTF) >$(build_dir)/vmlinux
+	$(VMLINUX_TO_BTF) >overlay/vmlinux
 endif
 ifeq ($(resolve_btfids_exists),0)
 ifeq ($(wildcard $(RESOLVE_BTFIDS)),)
-	@echo "ERROR: `resolve_btfids` not found; please compile it from Linux kernel source and re-run make with RESOLVE_BTFIDS=<path>"
+	@echo "ERROR: \`resolve_btfids\` not found; please compile it from Linux kernel source and re-run make with RESOLVE_BTFIDS=<path>"
 	@exit 1
 endif
-	install -Dm755 $(RESOLVE_BTFIDS) $(build_dir)/tools/bpf/resolve_btfids/resolve_btfids
+	install -Dm755 $(RESOLVE_BTFIDS) overlay/tools/bpf/resolve_btfids/resolve_btfids
 endif  # resolve_btfids_exists
 endif  # enable_build_hack
-	$(MAKE) -C $(build_dir) M=$(CURDIR) modules
+	$(BWRAP) $(MAKE) -C $(SYSTEM_BUILD_DIR) M=$(CURDIR) modules
 
 .PHONY: clean
 clean:
-	rm -rf build dkms.conf AKMBUILD
+	rm -rf overlay/
 	[ ! -d $(SYSTEM_BUILD_DIR) ] || $(MAKE) -C $(SYSTEM_BUILD_DIR) M=$(CURDIR) clean
 
 dkms.conf: dkms.conf.in
 	sed $^ \
 		-e 's|@@EXTRA_OPTS@@|CHECKSUM_HACK=$(CHECKSUM_HACK)|' \
-		-e 's|#MODULE_VERSION#|0.6.3|'> $@
+		-e 's|#MODULE_VERSION#|0.7.0|'> $@
 AKMBUILD: AKMBUILD.in
 	sed 's|@@EXTRA_OPTS@@|CHECKSUM_HACK=$(CHECKSUM_HACK)|' $^ > $@

=== debian/changelog ===
mimic (0.7.0+ds-2) unstable; urgency=medium

  * Add ppc64el and s390x to Architecture
  * mimic-dkms: move build hack dependencies to Recommends
  * Fix patch tags

 -- Eric Long <i@hack3r.moe>  Fri, 14 Mar 2025 13:18:17 +0800

mimic (0.7.0+ds-1) unstable; urgency=medium

  [ Eric Long ]
  * New upstream release.
  * Add autopkgtest integration-tests
  * Remove untested PowerPCs from Architecture
  * Use dh_installsysusers to fix piuparts
  * mimic-dkms: promote lz4 and xz-utils to Depends as they are used in
    official kernel (Closes: #1095728)
  * mimic-dkms: use bubblewrap for overlaying additional files on top of kernel
    module build directory (Closes: #1095722)
  * mimic-dkms: specify BUILD_EXCLUSIVE_KERNEL_MIN="6.1" and
    BUILD_EXCLUSIVE_CONFIG="CONFIG_DEBUG_INFO_BTF_MODULES"

  [ Andreas Beckmann ]
  * Declare Testsuite: autopkgtest-pkg-dkms.

 -- Eric Long <i@hack3r.moe>  Fri, 07 Mar 2025 17:52:17 +0800

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
  debhelper-compat (= 13),
  dh-sequence-dkms,
  dh-sequence-dlopenlibdeps,
+ dh-sequence-installsysusers,
  dh-exec,
  clang,
  python3,
@@ -15,15 +16,15 @@
  libffi-dev,
  libxdp-dev,
  linux-source,
- linux-headers-generic
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/hack3ric/mimic
 Rules-Requires-Root: no
+Vcs-Git: https://salsa.debian.org/hacker/mimic.git
 Vcs-Browser: https://salsa.debian.org/hacker/mimic
-Vcs-Git: https://salsa.debian.org/hacker/mimic.git
+Testsuite: autopkgtest-pkg-dkms
 
 Package: mimic
-Architecture: amd64 arm64 powerpc ppc64 ppc64el riscv64
+Architecture: amd64 arm64 riscv64 ppc64el s390x
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
@@ -41,21 +42,21 @@
 
 Package: mimic-dkms
 Section: kernel
-Architecture: amd64 arm64 powerpc ppc64 ppc64el riscv64
+Architecture: amd64 arm64 riscv64 ppc64el s390x
 Provides: mimic-modules (= ${binary:Version})
 Conflicts: mimic-modules
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
- binutils,
- pahole
 Recommends:
+ pahole,
+ bubblewrap,
  xz-utils,
+ lz4,
+ zstd,
  bzip2,
  lzma,
  lzop,
- lz4,
- zstd
 Description: eBPF UDP -> TCP obfuscator (DKMS kernel module)
  Mimic is an experimental UDP to TCP obfuscator designed to bypass UDP
  QoS and port blocking. Based on eBPF, it directly mangles data inside
@@ -65,3 +66,9 @@
  .
  This package uses DKMS to automatically build kernel module against
  current kernel.
+ .
+ Mimic works out-of-the-box with Debian kernel shipped in trixie (and
+ versions above) without mimic-dkms' Recommends. Older or third-party
+ kernels are supported with best effort and with Recommends, but your
+ milage may vary. Linux version less than (exclusive) 6.1 and s390x
+ with non-official kernels are not supported at all.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_VERSION_UPSTREAM

IS_UBUNTU := $(shell dpkg-vendor --derives-from ubuntu > /dev/null 2>&1; echo $$?)

njobs = 1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
njobs = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

%:
	dh $@

override_dh_auto_configure:
	sed install/mimic@.service.in \
		-e 's|@@MIMIC_EXEC@@|/usr/sbin/mimic|' \
		-e 's|@@MIMIC_CONFIG_PATH@@|/etc/mimic|' \
		-e 's|@@MIMIC_RUNTIME_DIR@@|mimic|' \
		> debian/mimic@.service
	sed kmod/dkms.conf.in \
		-e 's|@@EXTRA_OPTS@@|CHECKSUM_HACK=kfunc|' \
		> kmod/dkms.conf
	cp install/mimic.sysusers debian/mimic.sysusers

override_dh_auto_build:
	tar xf `bash -c '_tarballs=(/usr/src/linux-source-*.tar.*); echo $${_tarballs[0]}'`
ifeq ($(IS_UBUNTU),0)
#	Ubuntu's bpftool relies on current kernel, which is both inconsistent
#	with Debian and sbuild-unfriendly. Build from kernel source instead.
	make -j$(njobs) -C linux-source-*/tools/bpf/bpftool
	dh_auto_build -- build-cli build-tools generate-manpage \
		MODE= \
		BPF_CC=clang \
		USE_LIBXDP=1 \
		BPFTOOL=linux-source-*/tools/bpf/bpftool/bpftool
else
	dh_auto_build -- build-cli build-tools generate-manpage \
		MODE= \
		BPF_CC=clang \
		USE_LIBXDP=1
endif
	make -j$(njobs) -C linux-source-*/tools/bpf/resolve_btfids

override_dh_auto_test:

override_dh_dkms:
	dh_dkms -pmimic-dkms -V$(DEB_VERSION_UPSTREAM)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf linux-source-*
	rm -f debian/mimic@.service debian/mimic.sysusers

=== debian/tests/control ===
Tests: integration-tests
Depends: @,
 linux-image-generic,
 linux-headers-generic,
 bats,
 bc,
 conntrack,
 ethtool,
 jq,
 socat,
 tshark,
 wireguard-tools,
Restrictions: needs-root, isolation-machine, allow-stderr

=== debian/watch ===
version=4
opts=\
filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
downloadurlmangle=s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g,\
searchmode=plain,\
dversionmangle=auto,\
repacksuffix=+ds \
 https://api.github.com/repos/hack3ric/mimic/git/matching-refs/tags/v \
 https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
